#!/usr/bin/env python
#coding=utf-8

from airflow.models import DAG
from airflow.operators.bash_operator import BashOperator
from airflow.operators.subdag_operator import SubDagOperator
from subdags.idl_subdag import idl_subdag
import datetime
from config import *

default_args = {
    'owner' : 'wdc',
    'depends_on_past' : False,
    'start_date' : datetime.datetime(2017, 01, 01),
    'email' : ['wdc@huojutech.com'],
    'email_on_failure' : False,
    'email_on_retry': False,
    # 'retries' : 3,
    # 'retry_delay': datetime.timedelta(minutes=1),
}

DAG_NAME = 'daily_dag'

# 每天零点三十分执行
dag = DAG(
    dag_id=DAG_NAME,
    default_args=default_args,
    schedule_interval='30 0 * * *',
)

# 每日增量更新
odl_ad_television_incr_update = BashOperator(
    task_id='odl_ad_television_incr_update',
    bash_command='cd ' + SCRIPT_PATH + '; python odl_ad_television_incr_update.py',
    dag=dag,
)

# 每日排名更新
idl_rank_update = BashOperator(
    task_id='idl_rank_update',
    bash_command='cd ' + SCRIPT_PATH + '; python idl_rank_update.py',
    dag=dag,
)