#!/usr/bin/env python
#coding=utf-8

from airflow.models import DAG
from airflow.operators.bash_operator import BashOperator
from airflow.operators.subdag_operator import SubDagOperator
from subdags.idl_subdag import idl_subdag
import datetime
from config import *

default_args = {
    'owner' : 'wdc',
    'depends_on_past' : False,
    'start_date' : datetime.datetime(2017, 01, 01),
    'email' : ['wdc@huojutech.com'],
    'email_on_failure' : False,
    'email_on_retry': False,
    # 'retries' : 3,
    # 'retry_delay': datetime.timedelta(minutes=1),
}

DAG_NAME = 'realtime_dag'

dag = DAG(
    dag_id=DAG_NAME,
    default_args=default_args,
    schedule_interval='@once',
)

# 近实时计算(需要一直监听)
odl_near_realtime_calc = BashOperator(
    task_id='odl_near_realtime_calc',
    bash_command='cd ' + SCRIPT_PATH + '; python odl_near_realtime_calc.py & 2>&1 /root/py_script_logs/realtime.log',
    dag=dag,
)