#!/bin/bash

# 判断脚本执行路径是否存在，如果不存在则需要设置
if [ -z $HUOJU_FTY_PATH ];
then 
    echo "not found"
    export HUOJU_FTY_PATH=/root/py_script/
else
    echo "found"
fi
echo $HUOJU_FTY_PATH

###############################daily操作################################

# 电视台近一年平均收视率
echo "执行tmp_year_channel_avg_ratings_stat_by_tv province任务"
python ${HUOJU_FTY_PATH}task_tmp/tmp_year_channel_avg_ratings_stat_by_tv.py province
if [ $? -ne 0 ];
    then
        content="任务tmp_year_channel_avg_ratings_stat_by_tv province失败"
        echo $content
    exit 1
fi

echo "执行tmp_year_channel_avg_ratings_stat_by_tv area任务"
python ${HUOJU_FTY_PATH}task_tmp/tmp_year_channel_avg_ratings_stat_by_tv.py area
if [ $? -ne 0 ];
    then
        content="任务tmp_year_channel_avg_ratings_stat_by_tv area失败"
        echo $content
    exit 1
fi

# 按月统计电视剧的收视情况
echo "执行tmp_tv_avg_ratings_fatt0 province任务"
python ${HUOJU_FTY_PATH}task_tmp/tmp_tv_avg_ratings_fatt0.py province
if [ $? -ne 0 ];
    then
        content="任务tmp_tv_avg_ratings_fatt0 province失败"
        echo $content
    exit 1
fi
echo "执行tmp_tv_avg_ratings_stat province任务"
python ${HUOJU_FTY_PATH}task_tmp/tmp_tv_avg_ratings_stat.py province
if [ $? -ne 0 ];
    then
        content="任务tmp_tv_avg_ratings_stat province失败"
        echo $content
    exit 1
fi

echo "执行tmp_tv_avg_ratings_fatt0 area任务"
python ${HUOJU_FTY_PATH}task_tmp/tmp_tv_avg_ratings_fatt0.py area
if [ $? -ne 0 ];
    then
        content="任务tmp_tv_avg_ratings_fatt0 area失败"
        echo $content
    exit 1
fi
echo "执行tmp_tv_avg_ratings_stat area任务"
python ${HUOJU_FTY_PATH}task_tmp/tmp_tv_avg_ratings_stat.py area
if [ $? -ne 0 ];
    then
        content="任务tmp_tv_avg_ratings_stat area失败"
        echo $content
    exit 1
fi

# 电视台对应电视剧及类型关系数据
echo "执行tmp_tv_category_stat province任务"
python ${HUOJU_FTY_PATH}task_tmp/tmp_tv_category_stat.py province
if [ $? -ne 0 ];
    then
        content="任务tmp_tv_category_stat province失败"
        echo $content
    exit 1
fi
echo "执行tmp_tv_category_stat area任务"
python ${HUOJU_FTY_PATH}task_tmp/tmp_tv_category_stat.py area
if [ $? -ne 0 ];
    then
        content="任务tmp_tv_category_stat area失败"
        echo $content
    exit 1
fi

# 同步tv_avg_ratings_stat
echo "执行idl_tv_avg_ratings_stat province任务"
python ${HUOJU_FTY_PATH}task_idl/idl_tv_avg_ratings_stat.py province
if [ $? -ne 0 ];
    then
        content="任务idl_tv_avg_ratings_stat province失败"
        echo $content
    exit 1
fi
echo "执行idl_tv_avg_ratings_stat area任务"
python ${HUOJU_FTY_PATH}task_idl/idl_tv_avg_ratings_stat.py area
if [ $? -ne 0 ];
    then
        content="任务idl_tv_avg_ratings_stat area失败"
        echo $content
    exit 1
fi

# 同步tv_category_stat
echo "执行idl_tv_category_stat province任务"
python ${HUOJU_FTY_PATH}task_idl/idl_tv_category_stat.py province
if [ $? -ne 0 ];
    then
        content="任务idl_tv_category_stat province失败"
        echo $content
    exit 1
fi
echo "执行idl_tv_category_stat area任务"
python ${HUOJU_FTY_PATH}task_idl/idl_tv_category_stat.py area
if [ $? -ne 0 ];
    then
        content="任务idl_tv_category_stat area失败"
        echo $content
    exit 1
fi

# 同步year_channel_avg_ratings_stat
echo "执行idl_year_channel_avg_ratings_stat province任务"
python ${HUOJU_FTY_PATH}task_idl/idl_year_channel_avg_ratings_stat.py province
if [ $? -ne 0 ];
    then
        content="任务idl_year_channel_avg_ratings_stat province失败"
        echo $content
    exit 1
fi
echo "执行idl_year_channel_avg_ratings_stat area任务"
python ${HUOJU_FTY_PATH}task_idl/idl_year_channel_avg_ratings_stat.py area
if [ $? -ne 0 ];
    then
        content="任务idl_year_channel_avg_ratings_stat area失败"
        echo $content
    exit 1
fi

# 同步营销文章爬取数量
echo "执行idl_tv_article_marketing_count任务"
python ${HUOJU_FTY_PATH}task_idl/idl_tv_article_marketing_count.py
if [ $? -ne 0 ];
    then
        content="任务idl_tv_article_marketing_count失败"
        echo $content
    exit 1
fi

# 同步营销文章爬取链接
echo "执行idl_tv_article_marketing_detail任务"
python ${HUOJU_FTY_PATH}task_idl/idl_tv_article_marketing_detail.py
if [ $? -ne 0 ];
    then
        content="任务idl_tv_article_marketing_detail失败"
        echo $content
    exit 1
fi

# 类型转换
echo "执行transform_categories任务"
python ${HUOJU_FTY_PATH}task_other/transform_categories.py
if [ $? -ne 0 ];
    then
        content="任务transform_categories失败"
        echo $content
    exit 1
fi

# yxb字段清理
echo "执行ad_tv_lib_clean任务"
python ${HUOJU_FTY_PATH}task_yxb/ad_tv_lib_clean.py
if [ $? -ne 0 ];
    then
        content="任务ad_tv_lib_clean失败"
        echo $content
    exit 1
fi

# 排名
echo "执行idl_rank_update任务"
python ${HUOJU_FTY_PATH}task_other/idl_rank_update.py
if [ $? -ne 0 ];
    then
        content="idl_rank_update失败"
        echo $content
    exit 1
fi

echo "每天脚本执行完毕"